#!/etc/opt/openit/perl
# In rawarchiveregenerator.conf, the batchsize object value type is changed from String to Integer.


my $conf_file = "/var/opt/openit/etc/rawarchiveregenerator.conf";
my @lines = read_file( $conf_file );

my $index = 0;

$index = locate_line( $index, "rawarchiveregenerator", \@lines );
$index = locate_line( $index, "batchsize", \@lines );

if( $index != 0 )
{
	@lines[$index] =~ s/String/Integer/;
}

save_file( $conf_file, 2149, @lines );
print( "-- rawarchiveregenerator.conf successfully updated!\n" );
exit( 0 );


# Subroutines -----------

sub read_file {
	my ( $cfg ) = @_;
	open( IN, "$cfg" ) || die "ERROR: Unable to read cfg '$cfg'!\n";
	my @lines = <IN>;
	close( IN );
	return @lines;
}

sub locate_line {
	# For carets and colons, use the . character to represent them
	my ( $start, $find, $lines_ref ) = (@_);
	my ( $index ) = grep { @$lines_ref[$_] =~ /$find/ } $start ..@$lines_ref;
	return $index;
}

sub save_file {
	my ( $cfg, $patch, @lines ) = @_;
	my $old = "$cfg.pre_$patch";
	my $new = "$cfg.new";
	
	open( OUT, ">$new" ) || die "ERROR: Can't write new cfg '$new'!\n";
	print OUT @lines;
	close( OUT );
	
	if( ! rename( $cfg, $old ) ) {
		die "ERROR: Unable to rename previous config '$cfg' to '$old'!\n";
	}
	
	if( ! rename( $new, $cfg ) ) {
		die "ERROR: Unable to rename new config to '$cfg'!\n";
	}
}
